import logging
import random
import time

import requests

logging.basicConfig(level=logging.INFO,
                    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s',
                    datefmt='%Y-%m-%d %H:%M:%S',
                    filename='app.log',  # 日志文件名
                    filemode='a')


class NoneMobile(object):
    def __init__(self):
        self.count_mobile = 2  # 维持多少空号
        self.userid_list = []
        self.app_key = 'dingduoq7yuekcypoarz'
        self.app_secret = 'rlhrG-lFQVI6U8nNoYzcxJAFzmnA3n6c3cD7a_Cgj9mpG-fFyEQiCYkqGV7RPR0J'
        res = requests.get(
            f'https://oapi.dingtalk.com/gettoken?appkey={self.app_key}&appsecret={self.app_secret}').json()
        if res['errcode'] == 0:
            self.token = res['access_token']
        else:
            raise ValueError('Get Token Error')

    def generate_phone(self):
        # 基于三大运营商号段+随机数生成伪手机号
        ctcc = [133, 153, 173, 177, 180, 181, 189, 191, 193, 199]
        cucc = [130, 131, 132, 155, 156, 166, 175, 176, 185, 186, 166]
        cmcc = [134, 135, 136, 137, 138, 139, 147, 150, 151, 152, 157, 158, 159, 172, 178, 182, 183, 184, 187, 188, 198]
        begin = 10 ** 7
        end = 10 ** 8 - 1
        prefix = random.choice(ctcc + cucc + cmcc)
        return str(prefix) + str(random.randint(begin, end))

    def create_user(self):
        mobile_list = []
        i = 0
        while i < self.count_mobile:
            mobile = NoneMobile.generate_phone(self)
            while mobile in mobile_list:
                mobile = NoneMobile.generate_phone(self)
            data = {
                'name': time.time(),
                'mobile': mobile,
                'dept_id_list': '1'
            }
            res = requests.post(f'https://oapi.dingtalk.com/topapi/v2/user/create?access_token={self.token}',
                                json=data).json()
            print(res)
            # errcode 40103 已发出邀请，对方同意后即可加入组织
            if res['errcode'] == 0:
                mobile_list.append(mobile)
                NoneMobile.delete_user(self, res['result']['userid'])
                i += 1
            time.sleep(5)
        with open('mobile.txt', 'w') as f:
            for itme in mobile_list:
                f.write(f'{itme}\n')

    def delete_user(self, userid):
        data = {
            'userid': userid
        }
        res = requests.post(f'https://oapi.dingtalk.com/topapi/v2/user/delete?access_token={self.token}',
                            json=data).json()
        if res['errcode'] != 0:
            logging.info(f'Delete User Fail, User ID Is: {userid}  Msg: {res["errmsg"]}')


new = NoneMobile()
new.create_user()
